# CREDITS for Lazarr!

Lazarr! is a puzzle game by Wuzzy, using some textures, sounds and code from others.

It is free software, released under the conditions of the GNU GPL version 3, or any later version.
The media files are free cultural works, released under the CC BY-SA 4.0 license.

Details (and an explanation of all the license name abbreviations) follow:

## Source code

- `player_api` comes from Minetest Game 5.4.1 (modified for Lazarr!), by Minetest Game developers (see README.txt in this folder)
- `lzr_stairs` is a fork of the `stairs` mod of Minetest Game 5.4.1, by Minetest Game developers (see README.txt in this folder)
- `lzr_hook`, based on `screwdriver2` mod by 12Me21, modified version (CC0)
- `lzr_panes` is based on `xpanes` from Minetest Game and massively simplified (MIT License for code, CC BY-SA 3.0 for media)
- `lzr_decor` is based on `xdecor` by jp (BSD-3 clause license; massively-simplified version from the original)
- `no_fall_damage`, `no_multiplayer`, `show_wielded_item` by Wuzzy (CC0)
- `playerphysics` by Wuzzy (MIT)
- **All other mods that start with "`lzr_`" by Wuzzy (GPLv3+)**

## Levels

All levels by Wuzzy.

## Textures

- `farming_cotton_wild.png` by Extex101 (CC BY-SA 3.0)
- Water, wood (normal), tree (normal), stone (normal), sandstone brick, sandstone block, tools, hand, gold block, wooden chest, locked wooden chest, ship lightbox, player textures, crates, seaweed, purple coral, crab grass, fire, candle (standing, wall, wield), wool (cloth), blanket table, working table, cauldron, forge, bomb come from “PixelBOX” texture pack by jp (CC0)
- Sandstone, forge animation, cold forge, wood loose by Wuzzy (CC0)
	- Derivative work of PixelBox
- Hanging candle by Wuzzy (CC0)
- Raindrop by Wuzzy (CC0)
- Textures in `lzr_decor` mod made by jp (CC0)
- Barricade, dark chest, saw made by jp (CC0)
- Skulls by Mikita "rudzik8" Wiśniewski (CC BY-SA 3.0)
- Thatch by Mossmanikin and Neuromancer (CC BY-SA 4.0)
- Coconut and coconut tree by Neuromancer (CC BY-SA 4.0)
- Crosshair, wieldhand, `smoke_puff.png`: trivial textures by Wuzzy (CC0)
- `lzr_laser_overload_smoke.png`: by Wuzzy (CC0)
- Emitter, detector, dark locked chest, old crate, old barrel textures: Derivate works of xdecor textures by jp (CC0)
- Mirror textures: by Wuzzy (CC0)
- Screwdriver texture: by 12Me21 (CC0)
- Hotbar textures are a recolored version from from the hotbar textures of the Isabella Texture Pack by Bonemouse (http://www.minecraftforum.net/topic/242175-Isabella/) (CC BY 3.0)
- `default_dirt.png`, `default_grass.png`, `default_grass_side.png`, `default_rainforest_litter.png`, `default_rainforest_litter_side.png`, `default_sand.png`, `lzr_core_seabed.png`, `lzr_core_shrub_leaves.png`, `lzr_core_palm_leaves.png`. `lzr_core_palm_leaves_top.png`, `lzr_core_palm_tree.png`, `lzr_core_palm_tree_top.png`, `islands_tall_grass.png`, `lzr_core_island_stone.png`: by TheThermos (MIT)
- `lzr_gui_bg.png`: Based on two works:
	- 1) <https://opengameart.org/content/sheet-of-old-paper> by Q\_x (CC0)
	- 2) <https://opengameart.org/content/rpg-gui-construction-kit-v10> by Lamoot (CC BY 3.0)
- `lzr_gui_button.png`, `lzr_gui_button_hover.png`, `lzr_gui_button_pressed.png`:
	- Based on <https://opengameart.org/content/rpg-gui-construction-kit-v10> by Lamoot (CC BY 3.0)
- Hook texture: CraftPix.net 2D Game Assets
	- Derivate work of <https://opengameart.org/content/48-pirate-stuff-icons>
	- License: OGA-BY 3.0 <https://static.opengameart.org/OGA-BY-3.0.txt>
- `xocean_*.png`:
	- By StarNinjas
	- License: MIT
- `lzr_decor_ocean_pillar.png`:
	- By StarNinjas
	- License: MIT
	- Original file name `xocean_pillar.png`
- `lzr_decor_ocean_pillar_top.png`:
	- By StarNinjas and Wuzzy
	- Derivate work of `xocean_pillar.png`
	- License: MIT
- `lzr_decor_ocean_stone_block.png`:
	- By StarNinjas and Wuzzy
	- Derivate work of `xocean_stone.png`
	- License: MIT
- `lzr_menu_speaker_*.png`:
	- By MCL <temp1@cubesoftware.xyz>
	- License: CC BY 4.0
- `lzr_damage_screen_*.png`:
	- By Wuzzy
	- License: CC BY 4.0
- `lzr_laser_bomb_smoke_*.png`:
	- By Wuzzy
	- License: CC BY-SA 4.0

## Models

- Mirror models made by Wuzzy (CC0)
- Skull models made by Mikita "rudzik8" Wiśniewski (CC BY-SA 3.0)
- Player model comes from Minetest Game (see license of Minetest Game 5.4.1 for details)

## Sounds

- `lzr_ambience_ocean.ogg` comes from <https://freesound.org/people/inchadney/sounds/135805/>
	- by inchadney (CC BY 3.0)
- `lzr_ambience_temple.ogg` comes from <https://freesound.org/people/Zixem/sounds/69391/>
	- by Zixem (CC0)
- Mirror rotation sound comes from <https://freesound.org/people/killianm97/sounds/554236/>
	- by killanm97 (CC0)
- `lzr_hook_rotate.ogg`, `lzr_sounds_rotate_wood.ogg` come from <https://freesound.org/people/el_boss/sounds/560700/>
	- by `el_boss` (CC0)
- `lzr_sounds_rotate_stone.ogg` comes from <https://freesound.org/people/qubodup/sounds/743264/>
	- by qubodup (CC0)
- Glass sounds:
	- Footstep: Derivate work from <https://freesound.org/people/deleted_user_2104797/sounds/325252/>
		- by `deleted_user_2104797` (CC0)
	- Dig: Derivate work from <https://freesound.org/people/kelsey_w/sounds/467039/>
		- by `kelsey_w` (CC BY 3.0)
	- Place: Derivate work of <https://freesound.org/people/kbnevel/sounds/119839/>
		- by kbnevel (CC0)
- Wood sounds:
	- Footstep:
		- by Cpfcfan10
		- License: CC BY 4.0
		- Derivative work from <https://freesound.org/people/Cpfcfan10/sounds/522555/>
	- Place/dug:
		- by youandbiscuitme
		- License: CC BY 3.0
		- Origin: <https://freesound.org/people/youandbiscuitme/sounds/258244/>
		- Changes were made
- `lzr_laser_emitter_activate.ogg`: 
	- by PhonosUPF <https://freesound.org/people/PhonosUPF/sounds/501976/>
	- License: CC0
- `lzr_levels_level_start.ogg`: 
	- by Benboncan <https://freesound.org/people/Benboncan/sounds/77692/>
	- License: CC BY 4.0
- `lzr_levels_level_complete.ogg`:
	- by Fupicat <https://freesound.org/people/Fupicat/sounds/521641/>
	- Edit by Wuzzy (higher pitch)
	- License: CC0
- `lzr_levels_level_set_complete.ogg`:
	- "Pirate's Bounty.wav" by X3nus <https://freesound.org/s/449939/>
	- License: CC BY 4.0
- `lzr_sounds_button.ogg`:
	- by Fourier <https://opengameart.org/content/forward-button-press-ui-sound>
	- Edit by Wuzzy (shortened)
	- License: CC BY 3.0
- `lzr_laser_quickburn.*.ogg`:
	- Original by florianreichelt <https://freesound.org/people/florianreichelt/sounds/563012/>
	- Shortened for gameplay reasons
	- License: CC0
- `lzr_laser_barricade_break.ogg`:
	- By kevinkace <https://freesound.org/people/kevinkace/sounds/66780/>
	- License: CC0
- `lzr_laser_skull_footstep.*.ogg`:
- `lzr_laser_skull_place.*.ogg`:
- `lzr_laser_skull_dug.*.ogg`:
- `lzr_laser_skull_ghostly_dug.*.ogg`:
	- From the developers of Battle for Wesnoth (v1.18.2)
	- Original sound names (from the `data/core/sounds` directory of Battle for Wesnoth):
		- `skeleton-die-1.ogg`
		- `skeleton-die-2.ogg`
		- `skeleton-hit-1.ogg`
		- `skeleton-hit-2.ogg`
		- `skeleton-hit-3.ogg`
	- License: GPLv2+
- `lzr_sounds_dug_stone.*.ogg`:
- `default_dirt_footstep.*.ogg`,
- `default_dirt_place.*.ogg`,
- `default_dirt_dug.*.ogg`,
- `default_sand_footstep.*.ogg`,
- `lzr_sounds_dug_sand.*.ogg`,
- `lzr_sounds_place_sand.*.ogg`,
- `lzr_sounds_footstep_cloth.*.ogg`,
- `lzr_sounds_dug_cloth.*.ogg`,
- `lzr_sounds_place_cloth.*.ogg`,
- `lzr_sounds_footstep_leaves.*.ogg`,
- `lzr_sounds_footstep_grass.*.ogg`,
- `lzr_sounds_footstep_jungle_litter.*.ogg`,
- `lzr_sounds_dug_grass.*.ogg`,
- `lzr_sounds_dug_water.*.ogg`,
- `lzr_sounds_footstep_water.*.ogg`,
- `lzr_sounds_place_water.*.ogg`,
- `lzr_laser_barricade_footstep.*.ogg`,
- `lzr_laser_barricade_place.*.ogg`,
- `lzr_decor_footstep_forge.*.ogg`,
- `lzr_protection_inventory_full.ogg`:
	- by Wuzzy
	- License: MIT
- `lzr_sounds_wood_squeak.*.ogg`:
	- by rubberduck <https://opengameart.org/content/100-cc0-metal-and-wood-sfx>
	- License: CC0
- `lzr_treasure_chest_open.ogg`:
	- by JUDITH136 <https://freesound.org/people/JUDITH136/sounds/408001/>
	- License: CC BY 3.0
- `lzr_treasure_chest_open_fail.ogg`:
	- by Dymewiz <https://freesound.org/people/Dymewiz/sounds/131029/>
	- License: CC BY 3.0
- `lzr_treasure_chest_lock_break.ogg`:
	- by MAJ061785 <https://freesound.org/people/MAJ061785/sounds/85533/>
	- A shortened version of the original sound is used for this game
	- License: CC BY 3.0
- `lzr_treasure_chest_lock_regen.ogg`:
	- Heavily distorted derivative work of `lzr_treasure_chest_lock_break.ogg`
	- By Wuzzy and MAJ061785
	- License: CC BY 3.0
- `lzr_laser_detector_activate.ogg`
	- derivative work from sound by Artninja <https://freesound.org/people/Artninja/sounds/719255/>
	- License: CC BY 4.0
- `lzr_laser_detector_deactivate.ogg`
	- derivative work from sound by Artninja <https://freesound.org/people/Artninja/sounds/719255/>
	- License: CC BY 4.0
- `lzr_decor_lightbox_on.ogg`
	- derivative work from sound by Ryding <https://freesound.org/people/Ryding/sounds/718460/>
	- License: CC BY 4.0
- `lzr_decor_lightbox_off.ogg`
	- derivative work from sound by Ryding <https://freesound.org/people/Ryding/sounds/718460/>
	- License: CC BY 4.0
- `lzr_menu_speaker_turn_on.ogg`,
- `lzr_menu_speaker_turn_off.ogg`:
	- by mincedbeats <https://freesound.org/people/mincedbeats/sounds/593996/>
	- License: CC0
- `lzr_damage_damage.ogg`:
	- by newagesoup <https://freesound.org/people/newagesoup/sounds/348242/>
	- License: CC0
- `lzr_fallout_skull_laugh.ogg`:
	- by klankbeeld <https://freesound.org/people/klankbeeld/sounds/126113/>
	- original file name: laugh.WAV
	- sound was shortened a bit
	- License CC BY 4.0
- `lzr_laser_bomb_fuse.ogg`:
	- by maximumplay3r <https://freesound.org/people/maximumplay3r/sounds/713344/>
	- License: CC0
- `lzr_sounds_rotate_metal.ogg`:
	- by MultiMax2121 <https://freesound.org/people/MultiMax2121/sounds/156896/>
	- derivative work by Wuzzy
	- License: CC0
- `lzr_laser_bomb_explode.ogg`:
	- by WaveAdventurer <https://freesound.org/people/WaveAdventurer/sounds/732252/>
	- original name: explosion1(crunchier)
	- sound was shortened
	- License: CC BY 4.0
- `lzr_sounds_footstep_stone.*.ogg`:
	- By KieranKeegan
	- License: CC0
- `lzr_sounds_place_stone.*.ogg`:
	- By StarNinjas
	- License: CC0
- `lzr_laser_change_color.ogg`:
- `lzr_laser_change_screw.ogg`:
	- by artisticdue
	- Source: <https://opengameart.org/content/rpg-sound-pack> (`misc/random5.wav`)
	- License: CC0
- `lzr_laser_crate_old_break.*.ogg`:
	- by melle\_teich
	- Source: <https://freesound.org/people/melle_teich/sounds/628398/>
	- License: CC0

- All other sounds come from Minetest Game (see license of Minetest Game 5.4.1 for details)

## Translations

- German: Wuzzy
- Chinese (`zh_TW`): Emojigit
- Spanish: megustanlosfrijoles

## Other stuff

- See the licence files of the individual mods

## License references

The abbreviations above are license names. Here is a reference to all of them:

* GPLv3+: The GNU General Public License version 3, or any later version <https://www.gnu.org/licenses/gpl-3.0.en.html>
* GPLv2+: The GNU General Public License version 2, or any later version <https://www.gnu.org/licenses/old-licenses/gpl-2.0.en.html>
* MIT: The MIT License <https://mit-license.org/>
* CC0: Creative Commons Zero <https://creativecommons.org/publicdomain/zero/1.0/>
* CC BY 3.0: Creative Commons Attribution 3.0 Unported <https://creativecommons.org/licenses/by/3.0/>
* CC BY 4.0: Creative Commons Attribution 4.0 International <https://creativecommons.org/licenses/by/4.0/>
* CC BY-SA 3.0: Creative Commons Attribution-ShareAlike 3.0 Unported <https://creativecommons.org/licenses/by-sa/3.0/>
* CC BY-SA 4.0: Creative Commons Attribution-ShareAlike 4.0 International <https://creativecommons.org/licenses/by-sa/4.0/>
* OGA-BY 3.0: OpenGameArt.org Legal Code Attribution 3.0 Unported <https://static.opengameart.org/OGA-BY-3.0.txt>
